/*
    SDL - Simple DirectMedia Layer
    Copyright (C) 1997-2012 Sam Lantinga

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Sam Lantinga
    slouken@libsdl.org
*/
module org.libsdl.joystick;

import org.libsdl.stdinc;

struct SDL_Joystick {}

extern (C)
{
	int SDL_NumJoysticks();
	const(char)* SDL_JoystickName(int device_index);
	SDL_Joystick* SDL_JoystickOpen(int device_index);
	int SDL_JoystickOpened(int device_index);
	int SDL_JoystickIndex(SDL_Joystick* joystick);
	int SDL_JoystickNumAxes(SDL_Joystick* joystick);
	int SDL_JoystickNumBalls(SDL_Joystick* joystick);
	int SDL_JoystickNumHats(SDL_Joystick* joystick);
	int SDL_JoystickNumButtons(SDL_Joystick* joystick);
	void SDL_JoystickUpdate();
	int SDL_JoystickEventState(int state);
	Sint16 SDL_JoystickGetAxis(SDL_Joystick* joystick, int axis);
}

immutable int SDL_HAT_CENTERED  = 0x00;
immutable int SDL_HAT_UP        = 0x01;
immutable int SDL_HAT_RIGHT     = 0x02;
immutable int SDL_HAT_DOWN      = 0x04;
immutable int SDL_HAT_LEFT      = 0x08;
immutable int SDL_HAT_RIGHTUP   = SDL_HAT_RIGHT | SDL_HAT_UP;
immutable int SDL_HAT_RIGHTDOWN = SDL_HAT_RIGHT | SDL_HAT_DOWN;
immutable int SDL_HAT_LEFTUP    = SDL_HAT_LEFT | SDL_HAT_UP;
immutable int SDL_HAT_LEFTDOWN  = SDL_HAT_LEFT | SDL_HAT_DOWN;

extern (C)
{
	Uint8 SDL_JoystickGetHat(SDL_Joystick* joystick, int hat);
	int SDL_JoystickGetBall(SDL_Joystick* joystick, int ball, int* dx, int* dy);
	Uint8 SDL_JoystickGetButton(SDL_Joystick* joystick, int button);
	void SDL_JoystickClose(SDL_Joystick* joystick);
}
